import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as de, useState as D, useMemo as d, useEffect as ce, useRef as z, useCallback as je } from "react";
import { isMobile as p } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as ge, Table as T, Skeleton as ye } from "antd";
import Ne from "../../BitzDrawer/index.mjs";
import pe from "../../BitzLoadMore/index.mjs";
import we from "../../BitzPagination/index.mjs";
import ve from "../../BitzNoData/index.mjs";
import Ce, { TableContext as me } from "../Store/index.mjs";
import Be from "../TableSkeleton/index.mjs";
import { columnSort as K, genColumnKey as $ } from "../Store/utils/index.mjs";
import A from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import ze from "../../../node_modules/lodash-es/at.mjs";
function Te({
  showPagination: g = !0,
  fillEvenRow: k = !0,
  evenRowBgColor: u = "#f9f9f9",
  height: y,
  dataSource: l = [],
  total: w = 0,
  columns: f,
  loading: x = !1,
  skeletonNum: V = 2,
  skeletonRender: M,
  skeletonRowNum: U = 4,
  skeletonRowsWidth: X = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: q = () => {
  },
  mobileRefreshEmit: F = () => {
  },
  operationFilter: v,
  enableControlPage: G,
  pagination: J,
  paginationEmit: Q = () => {
  },
  mobilePageHeight: W = 500,
  mobileCancelText: Y = "取消",
  noDataTitle: Z,
  noDataImg: I,
  color: S,
  size: L,
  showTableTool: ee = !0,
  tableAction: ne,
  tableToolbar: se,
  selectionBar: le,
  scroll: i,
  resetPage: re,
  ...h
}) {
  const { token: oe } = ge.useToken(), t = de(me), [ie, C] = D(!1), te = d(() => !!(l != null && l.length) && (l == null ? void 0 : l.length) >= w, [l, w]), [ae, fe] = D([]), xe = (s, n) => {
    var o;
    const r = (o = v == null ? void 0 : v(s, n)) == null ? void 0 : o.filter(
      (a) => a.type !== "divider"
    );
    r != null && r.length && (fe(r), C(!0));
  }, E = () => {
    C(!1);
  }, he = (s) => {
    var n;
    C(!1), (n = s.onClick) == null || n.call(s);
  }, c = d(() => {
    const s = (r) => r.map((o) => {
      const a = $(
        (o == null ? void 0 : o.key) || (o == null ? void 0 : o.dataIndex),
        o.index
      ), j = t.columnsMap[a];
      return j && j.show === !1 ? !1 : o.children ? {
        ...o,
        children: s(o.children)
      } : o;
    }).filter(Boolean), n = s(f);
    return p ? n.sort(K(t.columnsMap)) : [
      T.SELECTION_COLUMN,
      T.EXPAND_COLUMN,
      ...n.sort(K(t.columnsMap))
    ];
  }, [t.columnsMap, f, p]);
  ce(() => {
    if (f && f.length > 0) {
      const s = f.map(
        (n) => (
          // @ts-ignore
          $((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      t.setSortKeyColumns(s);
    }
  }, [f]);
  const N = z(null), m = A(N), H = z(null), b = A(H), { y: B } = d(() => {
    if (typeof y > "u")
      return {};
    let s = 40, n = 40;
    if (N.current) {
      const j = window.getComputedStyle(N.current);
      s = parseInt(
        j.getPropertyValue("--cell-block") || "40"
      ), n = parseInt(
        j.getPropertyValue("--toolbar-height") || "40"
      );
    }
    const r = b == null ? void 0 : b.height;
    return { y: y - (r || 0) - n - s };
  }, [y, b == null ? void 0 : b.height, m == null ? void 0 : m.height]), be = z(null), O = d(() => i != null && i.x ? { x: i.x, y: i.y || B } : i != null && i.y ? l != null && l.length ? { x: 1e3, y: i.y } : { x: 1e3 } : l != null && l.length ? { x: 1e3, y: B } : { x: 1e3 }, [l, i, B]), P = d(() => `${L ?? (t == null ? void 0 : t.tableSize) ?? "lg"}BitzTable`, [L, t.tableSize]), R = d(() => ({
    "--evenRow-BgColor": u
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    u
    /** token.Table?.borderColor */
  ]), _ = je(
    (s, n) => k ? n % 2 === 0 ? "oddRow" : "evenRow" : "",
    [k]
  );
  return /* @__PURE__ */ e.jsxs("div", { className: "bitzTableBlock", children: [
    !p && /* @__PURE__ */ e.jsxs(
      "div",
      {
        ref: N,
        className: `bitzTableContainer ${P}`,
        style: { height: y },
        children: [
          /* @__PURE__ */ e.jsxs("div", { className: "bitzTableContainerBody", ref: be, children: [
            ee && /* @__PURE__ */ e.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              ne || /* @__PURE__ */ e.jsx("div", {}),
              se,
              (h == null ? void 0 : h.rowSelection) && /* @__PURE__ */ e.jsx(e.Fragment, { children: le })
            ] }),
            x ? /* @__PURE__ */ e.jsx(
              Be,
              {
                columns: c,
                dataLength: l == null ? void 0 : l.length,
                scroll: O,
                rowSelection: h.rowSelection,
                expandable: h.expandable,
                className: P,
                style: R,
                rowClassName: _
              }
            ) : /* @__PURE__ */ e.jsx(
              T,
              {
                columns: c,
                dataSource: l,
                loading: x,
                pagination: !1,
                scroll: O,
                ...h,
                style: R,
                rowClassName: _
              }
            )
          ] }),
          g && /* @__PURE__ */ e.jsx(
            we,
            {
              ref: H,
              enableControl: G,
              pagination: J,
              total: w,
              dataSource: l,
              resetPage: re,
              paginationEmit: Q
            }
          )
        ]
      }
    ),
    p && /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
      (x || (l == null ? void 0 : l.length) > 0) && /* @__PURE__ */ e.jsx(
        pe,
        {
          color: S,
          height: W,
          loading: x,
          showNoMore: te,
          refreshEmit: F,
          loadEmit: q,
          extra: /* @__PURE__ */ e.jsxs("div", { className: "mobileTable", children: [
            l == null ? void 0 : l.map((s, n) => /* @__PURE__ */ e.jsx(
              "div",
              {
                className: "mobileTableRow",
                onClick: () => xe(s, n),
                children: /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: c == null ? void 0 : c.map(
                  (r, o) => {
                    var a;
                    return /* @__PURE__ */ e.jsx("div", { children: !(r != null && r.mobileHideRow) && /* @__PURE__ */ e.jsxs("div", { className: "row", children: [
                      !r.mobileHideLabel && /* @__PURE__ */ e.jsxs("div", { className: "label", children: [
                        `${r.title}`,
                        "："
                      ] }),
                      /* @__PURE__ */ e.jsx("div", { className: "value", children: ((a = r == null ? void 0 : r.render) == null ? void 0 : a.call(
                        r,
                        ze(s, (r == null ? void 0 : r.dataIndex) || ""),
                        s,
                        n
                      )) || (s == null ? void 0 : s[r.dataIndex]) })
                    ] }) }, o);
                  }
                ) })
              },
              n
            )),
            x && Array.from({ length: V }).map((s, n) => /* @__PURE__ */ e.jsx("div", { className: "mobileTableRow", children: /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: M ? M() : /* @__PURE__ */ e.jsx(
              ye,
              {
                title: !1,
                paragraph: {
                  rows: U,
                  width: X
                },
                active: !0
              }
            ) }) }, n)),
            /* @__PURE__ */ e.jsx(
              Ne,
              {
                className: "tableMobileDrawer",
                open: ie,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: E,
                children: /* @__PURE__ */ e.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ e.jsx("div", { className: "boxBody", children: ae.map((s, n) => /* @__PURE__ */ e.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => he(s),
                      ...s.danger && {
                        style: { color: oe.colorError }
                      },
                      children: s.label
                    },
                    n
                  )) }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxFooter", onClick: E, children: Y })
                ] })
              }
            )
          ] })
        }
      ),
      !x && /* @__PURE__ */ e.jsx(ve, { data: l, title: Z, img: I })
    ] })
  ] });
}
const Ve = (g) => (
  // @ts-ignore
  /* @__PURE__ */ e.jsx(Ce, { initValue: g, children: /* @__PURE__ */ e.jsx(Te, { ...g }) })
);
export {
  Ve as default
};
